package scenegraph;

import javax.vecmath.*;

//backward compatibility. 
//should not be used..


public class Vector3 extends Vector3d{
	
	int hashCode;
	public int hashCode(){
        return hashCode;
    }
	static int global_hashCode = 0;
	
	public static final Vector3 X_AXIS = new Vector3(1, 0, 0);
	public static final Vector3 Y_AXIS = new Vector3(0, 1, 0);
	public static final Vector3 Z_AXIS = new Vector3(0, 0, 1);
	
	public String toString(){
		return ""+x+", "+y+", "+z;
	}
	public Vector3(){
		super();
		hashCode = global_hashCode++;
	}
	public Vector3(double x, double y, double z){
		super(x, y, z);
		hashCode = global_hashCode++;
	}
	public Vector3(Vector3d v){
		super(v);
		hashCode = global_hashCode++;
	}
	
	public double getLength(){
		return Math.sqrt(x*x+y*y+z*z);
	}
	static public Vector3 crossProduct(Vector3d u, Vector3d v){
		return new Vector3(u.y*v.z-u.z*v.y, 
						   u.z*v.x-u.x*v.z, 
						   u.x*v.y-u.y*v.x);
	}
	static public Vector3 subtract(Vector3d u, Vector3d v){
		return new Vector3(u.x-v.x, u.y-v.y, u.z-v.z);
	}
	static public Vector3 add(Vector3d u, Vector3d v){
		return new Vector3(u.x+v.x, u.y+v.y, u.z+v.z);
	}
	static public double dotProduct(Vector3d u, Vector3d v){
		return u.x*v.x+u.y*v.y+u.z*v.z;
	}
	static public Vector3 multiply(Vector3d v, double s){
		return new Vector3(s*v.x, s*v.y, s*v.z);
	}
	static public Vector3 normalizeV(Vector3d v){
		double l = Math.sqrt(v.x*v.x+v.y*v.y+v.z*v.z);
		return multiply(v, 1.0/l);
	}
	public void multiply(double s){
		x *= s;
		y *= s;
		z *= s;
	}
}
