package scenegraph;

public class Visual extends Node{
	public Geometry geometry;
	public Appearance frontFacingAppearance;
	public Appearance backFacingAppearance;
	
	int version=0;		// for display list compilation
	void request_update(){
		version++;
	}

	
	public void setGeometry(Geometry geometry){
		this.geometry = geometry;
		
		request_update();
		//update_requested = true;
	}
	public void setFrontFacingAppearance(Appearance appearance){
		this.frontFacingAppearance = appearance;
		
		request_update();
		//update_requested = true;
	}
	public void setBackFacingAppearance(Appearance appearance){
		this.backFacingAppearance = appearance;
		
		request_update();
		//update_requested = true;
	}

	//boolean update_requested = true;
	int display_list_id = -1;

}
