package jp.designinterface.evart.event;

import java.util.EventObject;

import jp.designinterface.evart.FrameOfData;

public class EVaRT2DataEvent extends EventObject {
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	private FrameOfData data = null;
	
	public EVaRT2DataEvent(Object source, FrameOfData data) {
		super(source);
		this.data = data;
	}
	
	public FrameOfData getFrameOfData() {
		return data;
	}
	
	public String toString() {
		return "Frame No.: " + data.Frame + " Body(s): " + data.NumBodies;
	}
}
