package scenegraph;

import javax.media.opengl.*;
import javax.vecmath.*;
public class RenderTarget extends GLCanvas{
	Renderer renderer;
	
	RenderTarget(){
		super();
	}
	public void setDisplayDevice(){
	}
	public java.awt.Component getAWTComponent(){
		return this;
	}
	Camera camera;
	public void addCamera(Camera camera ){
		this.camera = camera;
	}
	RendererListener renderedListener;
	public void addRendererListener( RendererListener listner ){
		renderedListener = listner;
	}
	
	
	public Vector3d transformFromViewportToCamera(Vector3d p, Camera camera){
		double[] q = renderer.screen_coords_to_world_coords(p.x, p.y, p.z);
		return new Vector3d(q[0], q[1], q[2]);
	}
	
	public Vector3d transformFromCameraToViewport(Vector3d p, Camera camera){
		double[] q = renderer.world_coords_to_screen_coords(p.x, p.y, p.z);
		return new Vector3d(q[0], q[1], q[2]);
		
	}

	
	public void paint(java.awt.Graphics g){
		super.paint(g);
		if (renderedListener != null)
			renderedListener.rendered(g);
	}
	public PickInfo pick(int x, int y, boolean flag0, boolean flag1){
		return renderer.pick(x, y);
	}
	public PickInfo pick(int x, int y){
		return renderer.pick(x, y);
	}
	

}
